package com.ynet.life.action;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.data.IndexedCollection;
import com.ynet.gene.data.KeyedCollection;
import com.ynet.life.base.LifeAction;
import com.ynet.life.base.Trace;

/* loaded from: com_ynet_life_action.jar:com/ynet/life/action/AddContextDataToICollAction.class */
public class AddContextDataToICollAction extends LifeAction {
    private String iCollName;

    public String execute(Context context) throws GENEException {
        try {
            IndexedCollection iColl = context.getDataElement(this.iCollName);
            KeyedCollection kColl = (KeyedCollection) iColl.getDataElement().clone();
            for (String key : kColl.keySet()) {
                if (context.containsKey(key)) {
                    IndexedCollection dataElement = context.getDataElement(key);
                    if (dataElement instanceof IndexedCollection) {
                        IndexedCollection subIColl = kColl.getDataElement(key);
                        IndexedCollection contextIColl = dataElement;
                        int size = contextIColl.size();
                        for (int i = 0; i < size; i++) {
                            subIColl.addDataElement((KeyedCollection) contextIColl.get(i));
                        }
                    } else {
                        kColl.setDataValue(key, context.getDataValue(key));
                    }
                }
            }
            iColl.addDataElement(kColl);
            return "0";
        } catch (GENEException empe) {
            Trace.logError("LifeAction", empe.getMessage(), empe);
            throw empe;
        }
    }

    public void setICollName(String iCollName) {
        this.iCollName = iCollName;
    }
}
